RR={
	Name			="Reticle Range",
	Version		="1.0",
	Icon			="/esoui/art/icons/achievement_087.dds",
	Range			={},
	RangeMin		=0,
	FontSize		=14,
	UI			={},	--WINDOW_MANAGER:CreateTopLevelWindow("RR_UI"),
	Fonts			={
				["standard"]	="/EsoUi/Common/Fonts/Univers57.otf",
				["esobold"]		="/EsoUi/Common/Fonts/Univers67.otf",
				},
	Defaults		={
				RR_UI	={TOPRIGHT,TOPLEFT,160,0},
				IconSize	=50,
				Count		=0,
				Visible	=true,
				},
	}

ZO_CreateStringId("SI_BINDING_NAME_RR_STRING_1", "Toggle ON/OFF")
ZO_CreateStringId("SI_BINDING_NAME_RR_STRING_2", "Button 2")

function RR:Menu_Init()
--local Settings=RR.Vars
local MenuOptions={
	-- Icon size
	{	type		="slider",
		name		="Icon size",
		tooltip	="",
		min		=20,
		max		=50,
		step		=10,
		getFunc	=function() return RR.Vars.IconSize end,
		setFunc	=function(value) RR.Vars.IconSize=value RR_Icon:SetDimensions(value, value) end,
		default	=RR.Defaults.IconSize,
	},
	}
	local MenuPanel={
	type="panel",
	name=RR.Name,
	displayName="|c4B8BFEChest Count|r",
	author="|c4B8BFEHoft|r",
	version=RR.Version,
	}
	local Menu=LibStub("LibAddonMenu-2.0")
	Menu:RegisterAddonPanel("RR_Menu", MenuPanel)
	Menu:RegisterOptionControls("RR_Menu", MenuOptions)
end

function RR:UI_Init()
	local size=50
	local fs=RR.FontSize
	local color={.8,.8,.8,1}
	local on		=RR.UI:TopLevelWindow("RR_UI",					GuiRoot,	{fs*1.5,size},			{CENTER,CENTER,40,0},			false)
--	on.tline		=RR.UI:Line(	"RR_UI_TLine",					on,		{fs*1.5+1.2,0},			{TOPLEFT,TOPLEFT,0,0},			color,1, false)
	on.rline		=RR.UI:Line(	"RR_UI_RLine",					on,		{0,size},				{TOPLEFT,TOPRIGHT,0,0},			color,1.2, false)
	on.bline		=RR.UI:Line(	"RR_UI_BLine",					on,		{fs*1.5+1.2,0},			{TOPLEFT,BOTTOMLEFT,0,0},		color,1.2, false)
	on.line={}
	on.label={}
	for i=1,6 do
	on.line[i]		=RR.UI:Line(	"RR_UI_Line"..i,					on,		{fs*1.5+1.2,0},			{TOPLEFT,TOPLEFT,0,fs*1.4*(i-1)},		color,1.2, true)
	on.label[i]		=RR.UI:Label(	"RR_UI_Label"..i,					on,		{fs*1.5,fs},			{TOPLEFT,TOPLEFT,0,fs*1.4*(i-1)},		RR.UI:Font("standard",fs,true), color, {1,0}, "", true)
	end
--	on:SetMouseEnabled(true)
--	on:SetMovable(true)
--	on:SetHandler("OnMouseDown", function(self,button) RR:ButtonHandler(button) end)
--	on:SetHandler("OnMouseUp", function(self) RR:SaveAnchor(self) end)
end

function RR.GetGange()
	control=_G["RR_UI"]
	if not DoesUnitExist('reticleover') then control:SetHidden(true) return end
	control:SetHidden(false)
	RR.Range		={}
	local fs		=RR.FontSize
	local _index	=1
	local _cgreen	={.8,.8,.8,1}
	local _cred		={.8,.2,.2,1}
	for i=3, 8 do
		local id=GetSlotBoundId(i)
		local minRange,maxRange=GetAbilityRange(id)
		if maxRange>0 then
			local confirm=true
			for j in pairs(RR.Range) do
				if RR.Range[j]~=nil and RR.Range[j].range==maxRange/100 then confirm=false end
			end
			if confirm then
				local status=HasRangeFailure(i)
				RR.Range[_index]={range=maxRange/100,status=status,slot=i}
				if status then RR.RangeMin=_index end
				_index=_index+1
	--			RR.Range[_index]={range=tostring(maxRange/100)..">",status=false}
			end
		end
	end
	table.sort(RR.Range, function(x,y) return x.range<y.range end)
	for i=1, 6 do
		if RR.Range[i]~=nil then
			control.line[i]:SetHidden(false)
			control.label[i]:SetHidden(false)
			control.label[i]:SetText(RR.Range[i].range)
			local color=(not RR.Range[i].status) and {.2,.8,.2,1} or {.8,.2,.2,1}
			control.label[i]:SetColor(unpack(color))
		else
			control.line[i]:SetHidden(true)
			control.label[i]:SetHidden(true)
		end
	end
	control:SetDimensions(fs*1.5,fs*1.4*(_index-1))
	control.rline:ClearAnchors()
	control.rline:SetAnchor(TOPLEFT, control, TOPRIGHT, 0, 0)
	control.rline:SetAnchor(BOTTOMRIGHT, control, TOPRIGHT, 0, fs*1.4*(_index-1))
end
--/script d(RR.Range)
--/script d(HasRangeFailure(5))
--/script d(GetAbilityRange(GetSlotBoundId(5)))
--abilityId=GetAbilityIdByIndex(abilityIndex)
--targetDescription=GetAbilityTargetDescription(abilityId)
--/script zo_callLater(function() d("6: "..tostring(HasRangeFailure(6)).." 7:"..tostring(HasRangeFailure(7))) end, 1000)

function RR.UI.Chain(object)
	-- Setup the metatable
	local T={}
	setmetatable(T, {__index=function(self, func)
		-- Know when to stop chaining
		if func=="__END" then return object end
		-- Otherwise, add the method to the parent object
		return function(self, ...)
			assert(object[func], func .. " missing in object")
			object[func](object, ...)
			return self
		end
	end})
	-- Return the metatable
	return T
end

function RR.UI:TopLevelWindow(name, parent, dims, anchor, hidden)
	-- Validate arguments
	if (name==nil or name=="") then return end
	parent=(parent==nil) and GuiRoot or parent
	if (#dims ~=2) then return end
	if (#anchor ~=4 and #anchor ~=5) then return end
	hidden=(hidden==nil) and false or hidden

	-- Create the window
	local window=_G[name]
	if (window==nil) then window=WINDOW_MANAGER:CreateTopLevelWindow(name) end

	-- Apply properties
	window=RR.UI.Chain(window)
		:SetDimensions(dims[1], dims[2])
		:ClearAnchors()
		:SetAnchor(anchor[1], #anchor==5 and anchor[5] or parent, anchor[2], anchor[3], anchor[4])
		:SetHidden(hidden)
	.__END
	return window
end

function RR.UI:Label(name, parent, dims, anchor, font, color, align, text, hidden)
	-- Validate arguments
	if (name==nil or name=="") then return end
	parent=(parent==nil) and GuiRoot or parent
	if (dims=="inherit" or #dims ~=2) then dims={parent:GetWidth(), parent:GetHeight()} end
	if (#anchor ~=4 and #anchor ~=5) then return end
	font	=(font==nil) and "ZoFontGame" or font
	color	=(color ~=nil and #color==4) and color or {1, 1, 1, 1}
	align	=(align ~=nil and #align==2) and align or {1, 1}
	hidden	=(hidden==nil) and false or hidden

	-- Create the label
	local label=_G[name]
	if (label==nil) then label=WINDOW_MANAGER:CreateControl(name, parent, CT_LABEL) end

	-- Apply properties
	local label=RR.UI.Chain(label)
		:SetDimensions(dims[1], dims[2])
		:ClearAnchors()
		:SetAnchor(anchor[1], #anchor==5 and anchor[5] or parent, anchor[2], anchor[3], anchor[4])
		:SetFont(font)
		:SetColor(color[1], color[2], color[3], color[4])
		:SetHorizontalAlignment(align[1])
		:SetVerticalAlignment(align[2])
		:SetText(text)
		:SetHidden(hidden)
	.__END
	return label
end

function RR.UI:Statusbar(name, parent, dims, anchor, color, tex, hidden)
	-- Validate arguments
	if (name==nil or name=="") then return end
	parent=(parent==nil) and GuiRoot or parent
	if (dims=="inherit" or #dims ~=2) then dims={parent:GetWidth(), parent:GetHeight()} end
	if (#anchor ~=4 and #anchor ~=5) then return end
	color=(color ~=nil and #color==4) and color or {1, 1, 1, 1}
	hidden=(hidden==nil) and false or hidden
	-- Create the status bar
	local bar=_G[name]
	if (bar==nil) then bar=WINDOW_MANAGER:CreateControl(name, parent, CT_STATUSBAR) end
	-- Apply properties
	local bar=RR.UI.Chain(bar)
		:SetDimensions(dims[1], dims[2])
		:ClearAnchors()
		:SetAnchor(anchor[1], #anchor==5 and anchor[5] or parent, anchor[2], anchor[3], anchor[4])
		:SetColor(color[1], color[2], color[3], color[4])
		:SetHidden(hidden)
		:SetTexture(tex)
	.__END
	return bar
end

function RR.UI:Line(name, parent, dims, anchor, color, thickness, hidden)
	-- Validate arguments
	if (name==nil or name=="") then return end
	parent=(parent==nil) and GuiRoot or parent
	if (dims=="inherit" or #dims ~=2) then dims={parent:GetWidth(), parent:GetHeight()} end
	if (#anchor ~=4 and #anchor ~=5) then return end
	color=(color ~=nil and #color==4) and color or {1, 1, 1, 1}
	hidden=(hidden==nil) and false or hidden
	-- Create the line
	local control=_G[name]
	if (control==nil) then control=WINDOW_MANAGER:CreateControl(name, parent, CT_LINE) end
	-- Apply properties
--	local control=RR.UI.Chain(control)
	control:ClearAnchors()
	control:SetAnchor(TOPLEFT, #anchor==5 and anchor[5] or parent, anchor[2], anchor[3], anchor[4])
	control:SetAnchor(BOTTOMRIGHT, #anchor==5 and anchor[5] or parent, anchor[2], anchor[3]+dims[1], anchor[4]+dims[2])
	control:SetColor(unpack(color))
	control:SetThickness(thickness)
	control:SetHidden(hidden)
--	.__END
	return control
end

function RR.UI:Font(font, size, shadow, outline)
	local font=( RR.Fonts[font] ~=nil ) and RR.Fonts[font] or font
	local size=size or 14
	local shadow=shadow and '|soft-shadow-thick' or ''
	if outline then shadow='|thick-outline' end
	return font..'|'..size..shadow
end

function RR.OnAddOnLoaded(eventCode,addonName)
	EVENT_MANAGER:UnregisterForEvent("RR_Ivent", EVENT_ADD_ON_LOADED)
--	RR.Vars=ZO_SavedVars:NewAccountWide("RR_Settings", 1, nil, RR.Defaults)
	zo_callLater(function()
		RR:UI_Init()
		EVENT_MANAGER:RegisterForUpdate("RR_Ivent1", 250, RR.GetGange)
	end, 1000)
end

EVENT_MANAGER:RegisterForEvent("RR_Ivent", EVENT_ADD_ON_LOADED, RR.OnAddOnLoaded)
